#include <stdio.h>
#include <windows.h>
#include "net.h"
#include "state.h"

#ifdef __MINGW32__
  extern int (__cdecl *bprintf) (int nStatus, TCHAR* szFormat, ...);
#else
  void bprintf(int nStatus, TCHAR* szFormat, ...){ }
#endif

extern int bAltPause;
int netGameInitialized;
Filep2pSync *myP2pSync;
unsigned char *pbad=NULL; //BurnAreaData pointer
unsigned int dSize=0;  //BurnAreaData size
unsigned int pbadIndex = 0;
//save
//TODO: should check w/ killer if it can be uchar *
static int __cdecl netGetStateAcb(struct BurnArea* pba){ //this should "replace" BurnAcb
	
	memcpy(pbad + pbadIndex, pba->Data, pba->nLen);
	pbadIndex += pba->nLen;
	
	return 0;
}

static int __cdecl netGetStateLenAcb(struct BurnArea* pba){
	dSize += pba->nLen; 
	
	return 0;
}

static void netSaveState( unsigned char **data, unsigned int *size){
	if(pbad || dSize){
		free( pbad );
		pbad = NULL;
		dSize = 0;
		pbadIndex = 0;
	}
	//let's get mem size needed
	BurnAcb = netGetStateLenAcb;
	BurnAreaScan(ACB_FULLSCAN | ACB_READ, NULL);
	if(dSize <= 0)
		return;
	
	pbad = (unsigned char *)malloc( dSize*sizeof(unsigned char) );
	
	BurnAcb = netGetStateAcb; //define callback
	BurnAreaScan(ACB_FULLSCAN | ACB_READ, NULL);	 //this one calls BurnAcb
	//everything from here is Ok to be read
	*size = dSize;

	if( !(*data) )
		*data = (unsigned char *)malloc( dSize*sizeof(unsigned char) );
	memcpy(*data, pbad, dSize);
	
	bprintf(0,"net.cpp:Fetched %d bytes\n", *size);
	
	free( pbad );
	pbad = NULL;
	dSize=0;
	pbadIndex = 0;
	
}



//load

static int __cdecl netSetState(struct BurnArea* pba){ //this should "replace" BurnAcb
	
	
	memcpy(pba->Data, pbad + pbadIndex, pba->nLen);
	pbadIndex += pba->nLen;
	
	
	return 0;
}


static void netLoadState( unsigned char *data, unsigned int size){
	//need to set stuff before setting state
	if(pbad || dSize){
		free( pbad );
		pbad = NULL;
		dSize = 0;
		pbadIndex = 0;
	}
	
	dSize = size;
	pbad = (unsigned char *)malloc( dSize*sizeof(unsigned char) );
	memcpy(pbad, data, dSize);
	
	//finished setting
	BurnAcb = netSetState;
	BurnAreaScan(ACB_FULLSCAN | ACB_READ, NULL);
	
	free( pbad );
	pbad = NULL;
	dSize = 0;
	pbadIndex = 0;
	
}//remember to free that data ptr!

static void __cdecl pauseGame(){
	bAltPause = 1;
}
static void __cdecl unPauseGame(){
	bAltPause = 0;
}

int Init_Network(void)
{
	struct p2pCallBacks *pCB = (struct p2pCallBacks *)malloc( sizeof(struct p2pCallBacks) );
	pCB->stateSavePtr   = netSaveState;
	pCB->stateLoadPtr   = netLoadState;
	pCB->pauseGamePtr   = pauseGame;
	pCB->unPauseGamePtr = unPauseGame;
	myP2pSync = new Filep2pSync("replaced.txt",pCB);
	free(pCB);
	return 0;
}


void End_Network(void)
{
	if (netGameInitialized)
	{
		delete myP2pSync;
	}
}
