#include "Filep2pSync.h"
#include "MessageManager.h"

#include <fstream>
#include <sstream>

#include <assert.h>

#ifdef __MINGW32__
  #define DPRINT if(1)bprintf
  extern int (__cdecl *bprintf) (int nStatus, TCHAR* szFormat, ...);
#else
  #define DPRINT if(1)bprintfFPS
  void bprintfFPS(int nStatus, TCHAR* szFormat, ...){ }
#endif

using namespace std;




void fasttrim(string& str){
  string::size_type pos = str.find_last_not_of(' ');
  if(pos != string::npos) {
    str.erase(pos + 1);
    pos = str.find_first_not_of(' ');
    if(pos != string::npos) str.erase(0, pos);
  }
  else str.erase(str.begin(), str.end());


}


Filep2pSync::Filep2pSync(char *filename, struct p2pCallBacks *pCB)
: p2pSync(pCB)
{
	list<string> lIPs;
  DPRINT(0,"Opening %s\n",filename);
  ifstream fgameconf(filename);
  
  if( !fgameconf ){
    DPRINT(1,"Couldn't open file '%s'\n",filename);
  }

  #define MAX_LENGTH 80
  char line[MAX_LENGTH];

  fgameconf.getline(line,MAX_LENGTH);
  
  int gameID = atoi(line);

  fgameconf.getline(line,MAX_LENGTH);
  std::string gameNameSTR=line;

  int playerNo=0, // first player is 1, second is 2...
      iPlayer = 0; 
  while(fgameconf.getline(line,MAX_LENGTH)){
    string str1(line);
    fasttrim(str1);
    if(str1.length() == 0) //this one's in case of last empty line
      continue;

    iPlayer++;
    
    if(str1 == "home" && playerNo == 0){
      playerNo = iPlayer;
    }

    lIPs.push_back(str1);
  }
  int totalPlayers = iPlayer;
  fgameconf.close();

  setData(lIPs, gameNameSTR, playerNo, totalPlayers, gameID);

}

Filep2pSync::~Filep2pSync(){ }
/*
void Filep2pSync::sync(unsigned char *data, int size){
  p2pSync::sync(data, size);
}
void Filep2pSync::setGameCallback(int (WINAPI *gameCallbackIn)(char *game, int player, int numplayers)){
  DPRINT(0,"New school setting\n");
  p2pSync::setGameCallback(gameCallbackIn);
}
*/


