#include "P2pMessage.h"

#define DEFAULT_PRIORITY 0

P2pMessage::P2pMessage( unsigned char *inputBufIn, int bufSizeIn, int numToConfirmIn, int originalFrameIn){

  numToConfirm = numToConfirmIn;
  bufSize = bufSizeIn;

  inputBuf = new unsigned char[bufSize];
  for(int i=0; i < bufSize; i++)
    inputBuf[i] = inputBufIn[i];
  
	beenConfirmed = false;
	
	originalFrame = originalFrameIn;
	highestFrameBounce = -1;
	createdTime = clock()+(CLOCKS_PER_SEC*MS_ERROR_MARGIN)/1000;
}
P2pMessage::~P2pMessage(){
	delete[] inputBuf;
  confirmed.clear();
}

void P2pMessage::playerConfirm(int playerNo){
  confirmed.insert(playerNo);
}
void P2pMessage::playerDeConfirm(int playerNoIn, int hfbIn){
	unConfirmed.insert(playerNoIn);
	if(highestFrameBounce < hfbIn)
		highestFrameBounce = hfbIn;
}
int P2pMessage::getInput( unsigned char *outputBuf){
  for(int i=0; i < bufSize; i++)
    outputBuf[i] = inputBuf[i];
	
	return bufSize;
}

void P2pMessage::fullConfirm(){
	beenConfirmed = true;
}

bool P2pMessage::isReady(){
  return beenConfirmed || (confirmed.size()+unConfirmed.size() == numToConfirm);
}

clock_t P2pMessage::getCreatedTime(){
	return createdTime;
}

int P2pMessage::getFrameBounce(){
	return highestFrameBounce;
}
int P2pMessage::getOriginalFrame(){
	return originalFrame;
}

