#ifndef P2PMESSAGE
#define P2PMESSAGE

#include <set>
#include <time.h>

#define MS_ERROR_MARGIN 1 //margin for creation time

class P2pMessage{
  public:
    P2pMessage(unsigned char *inputBuf, int bufSize, int numToConfirm, int originalFrame);
    ~P2pMessage();
    void playerConfirm(int playerNo);
		void playerDeConfirm(int playerNo, int frameBounce);
    int getInput(unsigned char outputBuf[]);
    bool isReady();
		void fullConfirm();
		int getOriginalFrame();
		int getFrameBounce();
		clock_t getCreatedTime();
  protected:
		int originalFrame; 
    unsigned char *inputBuf;
    int bufSize;
    unsigned int numToConfirm;//unsigned because of STL.size()
    unsigned int createTime;
    std::set<int> confirmed;
		std::set<int> unConfirmed;
		bool beenConfirmed;
		clock_t createdTime;
		int highestFrameBounce;
};
#endif
