class P2pPlayer;
#ifndef P2PPLAYER
#define P2PPLAYER

#include <map>
#include "P2pSync.h"

class P2pMessage;
struct gameInfo;

class P2pPlayer {
  public:
    P2pPlayer(int playerNo, gameInfo *GI);
    ~P2pPlayer();
    bool setInput( unsigned char *inBuf, int size, int frameNo); //used when confirmed msg
		
    int getInput( unsigned char *outBuf, int frameNo);
    int getSetCache( unsigned char *outBuf);
    void clearInput( int frameNo );
		void confirmMsg( int frameNo );
		void deConfirmMsg( int frameNo );
		void confirmBounce( int originalFrame, int frameNo );
		void bounceInput( int oldInput, int newInput);
		int inputReady( int frameNo ); //returns conflicting original frame input
  public:
    
    bool ready;
  protected:
		std::map<int, P2pMessage *> inputMsgCache;
		std::multimap<int, P2pMessage *> bounceInputMsgCache; //must be separated: setInput != killBounceInput, and can't have them both
		int lastOriginalFrameProcessed;
    struct gameInfo *myGI;
    int nextFrameNo; 
    //int inputSize;
    unsigned char *inputCache; //cache from getInput
    unsigned char *setInputCache; //cache from setInput
    int playerNo;
};
#endif
