#include "P2pSem.h"
#include <time.h>
#ifdef __MINGW32__
  #define DPRINT if(FBA_DEBUG)bprintf
  extern int (__cdecl *bprintf) (int nStatus, TCHAR* szFormat, ...);
#else
  #define DPRINT if(0)bprintfSem
  void bprintfSem(int nStatus, TCHAR* szFormat, ...){ }
#endif

int P2pSem::semCount = 0;

#define MAX_SEM_COUNT 50

#include <string>
#include <sstream>
using namespace std;

P2pSem::P2pSem(){
  
  sem = CreateSemaphore(
            NULL, //security defaults
            1, //initial count
            MAX_SEM_COUNT,
            NULL); //unnamed semaphore
  
	mySemID = ++semCount;
	ostringstream eventName;
	eventName << "semEvent" << mySemID;
	
	hEvent = CreateEvent(NULL, FALSE, FALSE, NULL );
  
  if(GetLastError() == ERROR_ALREADY_EXISTS || hEvent == NULL || sem == NULL){
    DPRINT(1,"Problems with threads!\n");
  }
  DPRINT(0,"Created sem #%d=%d for Thread %d:\n", mySemID, semCount, GetCurrentThreadId());
}
P2pSem::~P2pSem(){
    CloseHandle(sem);
		CloseHandle(hEvent);
}
void P2pSem::enterCritical(){
  
     DWORD dwWaitResult =
      WaitForSingleObject( sem, INFINITE);           // zero-second time-out interval
  switch(dwWaitResult){
    case WAIT_OBJECT_0:
      break;
    default:
      DPRINT(1,"#%d:This is not expected\n",mySemID);
      break;
  }
   
      

}
void P2pSem::exitCritical(){
  
  if (!ReleaseSemaphore(
                          sem,  // handle to semaphore
                          1,            // increase count by one
                          NULL) ) // not interested in previous count
      DPRINT(1,"Couldn't release semaphore:%d!\n",GetLastError());

}

int P2pSem::waitForGreenLight(int ms = -1){
	//clock_t clk = clock();
	
	DWORD dwWaitResult;
	if(ms < 0)
		dwWaitResult = WaitForSingleObject(hEvent,INFINITE);
	else
		dwWaitResult = WaitForSingleObject(hEvent,ms);
		
	//DPRINT(0,"sem:Waited %dms for singleob\n", (clock() - clk)*1000/CLOCKS_PER_SEC);
	
	switch(dwWaitResult){
		case WAIT_OBJECT_0:
			return 0;
			break;
		case WAIT_TIMEOUT:
			return 1;
			break;
		default:
			DPRINT(1,"sem:Problems waiting\n");
			return -1;
			break;
	}
	
	//ResetEvent(hEvent);
	
}
void P2pSem::greenLight(){
	if ( !SetEvent(hEvent) ) 
    DPRINT(0,"sem:SetEvent failed (%d)\n", GetLastError());
	ResetEvent(hEvent);
}

