#include "WinMessage.h"

extern int clk2ms(clock_t in); 

WinMessage::WinMessage( char *bufIn, int bufSizeIn, int msLater, int retriesIn){
	bufSize = bufSizeIn;
	buf = new char[bufSize];
	for(int i=0; i< bufSize; i++)
		buf[i] = bufIn[i];
	
	time2send = clock()+(CLOCKS_PER_SEC*msLater)/1000;
	retries = retriesIn;
}
WinMessage::~WinMessage(){
	delete[] buf;
}

int WinMessage::getSize(){
	return bufSize;
}

bool WinMessage::ready2send(){
	return clock() >= time2send;
}


int WinMessage::getContent(char *bufOut){
	if(retries <= 0){
		return -1;
	}
	
	for(int i=0; i< bufSize; i++)
		bufOut[i] = buf[i];
	
	retries--;
	return bufSize;
}

