#ifndef WINMSGMANAGER
#define WINMSGMANAGER

#include "MessageManager.h"


/* Win32 includes*/
#ifndef WIN32_LEAN_AND_MEAN
  #define WIN32_LEAN_AND_MEAN
#endif
#ifndef _WIN32_WINNT
  #include <windows.h>
#endif
#include <winsock2.h>
#include <ws2tcpip.h>
#include <iphlpapi.h>

#define MAX_BUF 512
//class WinMessage;
#include "WinMessage.h"
class WinNodeInfo;
#include "WinNodeInfo.h"



class WinMessageManager : public MessageManager
{
	public:
		WinMessageManager(std::list<std::string> lIPaddr, CalleeBack *callee);
		~WinMessageManager();
	public:
		static DWORD receiveThreadStart(void *param);//http://www.gamedev.net/community/forums/topic.asp?topic_id=169896
		static DWORD redundantThreadStart(void *param);//http://www.gamedev.net/community/forums/topic.asp?topic_id=169896
	protected:
		static bool initialized;
		bool initWSocks();
    bool initListening();
		SOCKET mainSock;             //!Everything goes through here
    WSADATA wsaData;
    std::string getKey(sockaddr_in sockin);
		P2pSem *reduntSem;

		void getKeyed(std::string in, sockaddr_in* out);
	protected: //redundancy and queue
		bool redundantLooping;
		void redundantLoop();
		void checkForQueued();
	protected://from MM
		void basicSend( char *buf, int size, std::string addrIn,bool block = true);
		int tryAndReceive(bool shortWait);
		void sendLater(char *buf, int size, std::string addr, int deltaInMs);
		void store(std::string addrIn);
};


#endif


